//+------------------------------------------------------------------+
//+------------------------------------------------------------------
//|                                                     
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Silver
#property indicator_color2  Red
#property indicator_width1  2

//
//
//
//
//

extern int    FastMa          = 12;
extern int    FastMaMode      = 1;
extern int    FastMaPrice     = 0;
extern int    SlowMa          = 26;
extern int    SlowMaMode      = 1;
extern int    SlowMaPrice     = 0;
extern int    SignalMa        = 9;
extern int    SignalMaMode    = 1;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

extern bool   ShowText        = true;
extern int    textXPosition   = 5;
extern int    textYPosition   = 30;
extern color  upTextcolor     = Blue;
extern color  dnTextcolor     = Red;
extern int    upFontsize      = 12;
extern int    dnFontsize      = 12;

//
//
//
//
//

double macd[];
double sign[];
double trend[];
string TextDir = "Macd Text";
string macdText;

//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,macd); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sign);
   SetIndexBuffer(2,trend);
   IndicatorShortName("MACD("+FastMa+","+SlowMa+","+SignalMa+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
return(0);
}

int deinit()  
{   
   ObjectDelete(TextDir);
   
return(0);  
}

//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
         
      //
      //
      //
      //
      //

      for(i = limit; i>=0; i--) macd[i] = iMA(NULL,0,FastMa,0,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMa,0,SlowMaMode,SlowMaPrice,i);
      for(i = limit; i>=0; i--) sign[i] = iMAOnArray(macd,Bars,SignalMa,0,SignalMaMode,i);
      for(i = limit; i>=0; i--) 
      {
         trend[i] = trend[i+1];
         macdText = macd[i];
         if (macd[i] > 0) { trend[i] = 1; Commenter(1);  }
         if (macd[i] < 0) { trend[i] =-1; Commenter(-1); }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("Buy");
        else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MACD "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//
//
//
//
//

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
         ObjectSet(TextDir,OBJPROP_XDISTANCE,textXPosition);
         ObjectSet(TextDir,OBJPROP_YDISTANCE,textYPosition);
         if (Dir == 1) ObjectSetText(TextDir,macdText,upFontsize,"Arial Black",upTextcolor);
         if (Dir ==-1) ObjectSetText(TextDir,macdText,dnFontsize,"Arial Black",dnTextcolor);
    }
   
return; 
}